package com.microservices.pms.productLibrary.service.impl;

import com.microservices.common.core.utils.DateUtils;
import com.microservices.common.security.utils.SecurityUtils;
import com.microservices.pms.productLibrary.domain.PmsProductlibJyrjd;
import com.microservices.pms.productLibrary.mapper.PmsProductlibJyrjdMapper;
import com.microservices.pms.productLibrary.service.IPmsProductlibJyrjdService;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * (PmsProductlibJyrjd)表服务实现类
 *
 * @author makejava
 * @since 2023-12-08 15:09:21
 */
@Service("pmsProductlibJyrjdService")
public class PmsProductlibJyrjdServiceImpl implements IPmsProductlibJyrjdService {

    @Resource
    private PmsProductlibJyrjdMapper pmsProductlibJyrjdMapper;

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public PmsProductlibJyrjd queryById(Integer id) {
        return this.pmsProductlibJyrjdMapper.queryById(id);
    }

    /**
     * 分页查询
     *
     * @param pmsProductlibJyrjd 筛选条件
     * @param pageRequest        分页对象
     * @return 查询结果
     */
    @Override
    public Page<PmsProductlibJyrjd> queryByPage(PmsProductlibJyrjd pmsProductlibJyrjd, PageRequest pageRequest) {
        long total = this.pmsProductlibJyrjdMapper.count(pmsProductlibJyrjd);
        return new PageImpl<>(this.pmsProductlibJyrjdMapper.queryAllByLimit(pmsProductlibJyrjd, pageRequest), pageRequest, total);
    }

    /**
     * 新增数据
     *
     * @param pmsProductlibJyrjd 实例对象
     * @return 实例对象
     */
    @Override
    public PmsProductlibJyrjd insert(PmsProductlibJyrjd pmsProductlibJyrjd) {
        pmsProductlibJyrjd.setCreateTime(DateUtils.getNowDate());
        pmsProductlibJyrjd.setCreateBy(SecurityUtils.getUsername());
        pmsProductlibJyrjd.setUpdateTime(DateUtils.getNowDate());
        pmsProductlibJyrjd.setUpdateBy(SecurityUtils.getUsername());
        this.pmsProductlibJyrjdMapper.insert(pmsProductlibJyrjd);
        return pmsProductlibJyrjd;
    }

    /**
     * 修改数据
     *
     * @param pmsProductlibJyrjd 实例对象
     * @return 实例对象
     */
    @Override
    public PmsProductlibJyrjd update(PmsProductlibJyrjd pmsProductlibJyrjd) {
        pmsProductlibJyrjd.setUpdateTime(DateUtils.getNowDate());
        pmsProductlibJyrjd.setUpdateBy(SecurityUtils.getUsername());
        this.pmsProductlibJyrjdMapper.update(pmsProductlibJyrjd);
        return this.queryById(pmsProductlibJyrjd.getId());
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Integer id) {
        return this.pmsProductlibJyrjdMapper.deleteById(id) > 0;
    }

    @Override
    public Long queryCount(PmsProductlibJyrjd pmsProductlibJyrjd) {
        return this.pmsProductlibJyrjdMapper.count(pmsProductlibJyrjd);
    }

    @Override
    public boolean deleteByPath(String path) {
        return this.pmsProductlibJyrjdMapper.deleteByPath(path) > 0;
    }

    @Override
    public PmsProductlibJyrjd queryByPath(String name) {
        return pmsProductlibJyrjdMapper.queryByPath(name);
    }

    @Override
    public PmsProductlibJyrjd queryByPmsProductlibJyrjd(PmsProductlibJyrjd pmsProductlibJyrjd) {
        return this.pmsProductlibJyrjdMapper.queryByPmsProductlibJyrjd(pmsProductlibJyrjd);
    }
}
